% Programm zur Loesung der Aufgabe 10.8 mit einem FE-Verfahren, lineare Elemente
% -((1+c*x^2)u_x)_x + d*u = exp(-x^2), u(0)=0, [u_x + alpha*u](1) = peta
% Input:  c,d,alpha,peta und Zahl der Elemente n
% Output: Loesung u an den Stuetzstellen x, Matrix a und rechte Seite f
% Aufruf: [u,x,a,f] = aufg98fem1(c,d,alpha,peta,n);
function [u,x,a,f] = aufg98fem1(c,d,alpha,peta,n);
h = 1/n;
f = zeros(n,1);
x(1)=0;
for i=1:n
   x(i+1)=i*h;
end
% Aufbau der Steifigkeitsmatrix a und des Lastvektors f
for i=1:n
   if (i == 1)
     a(i,i) = (2+c*(x(i)^2+x(i+1)^2+h*(x(i)+x(i+1))+2*h^2/3))/h + d*2*h/3; 
     a(i,i+1) = -(1+c*(x(i+1)^2+h*x(i+1)+h^2/3))/h +d*h/6;
     f(i) = exp(-(x(i)+h/2)^2)*h/3+exp(-(x(i+1)+h/2)^2)*h/3+exp(-x(i+1)^2)*h/3;
   end
   if (1 < i && i < n)
     a(i,i-1) = -(1+c*(x(i)^2+h*x(i)+h^2/3))/h + d*h/6; 
     a(i,i+1) = -(1+c*(x(i+1)^2+h*x(i+1)+h^2/3))/h +d*h/6;
     a(i,i) = (2+c*(x(i)^2+x(i+1)^2+h*(x(i)+x(i+1))+2*h^2/3))/h + d*2*h/3;
     f(i) = exp(-(x(i)+h/2)^2)*h/3+exp(-(x(i+1)+h/2)^2)*h/3+exp(-x(i+1)^2)*h/3;
   end
   if (i == n)
     a(i,i-1) = -(1+c*(x(i)^2+h*x(i)+h^2/3))/h + d*h/6;
     a(i,i) = (1+c*(x(i)^2+h*x(i)+h^2/3))/h + d*1*h/3 +2*alpha;
     f(i) = exp(-(x(i)+h/2)^2)*h/3+exp(-x(i+1)^2)*h/6 +2*peta;
   end
end
% Loesung
uu = a\f;
u(1)=0;
for i=1:n
   u(i+1) = uu(i);
end
end
