% Programm zur Loesung der Aufgabe 10.8 mit einem FV-Verfahren
% -((1+c*x^2)u_x)_x + d*u = exp(-x^2), u(0)=0, [u_x + alpha*u](1) = peta
% Stuetzwerte u_i an den Stuetzstellen x_{i-1/2}, i=1,...,n
% Input:  c,d,alpha,peta und Zahl der Stuetzstellen n
% Output: Loesung u an den Stuetzstellen x, Matrix a und rechte Seite f
% Aufruf: [u,x,a,f] = aufg98fvm(c,d,alpha,peta,n);
function [u,x,a,f] = aufg98fvm(c,d,alpha,peta,n);
h = 1/n;
f = zeros(n,1);
for i=1:n
   x(i)=(i-1/2)*h;
end
% Aufbau der Steifigkeitsmatrix a und des Lastvektors f
for i=1:n
   if (i == 1)
     a(i,i) = 2/h + (1+c*h^2)/h + d*h; a(i,i+1) = -(1+c*h^2)/h;
     f(i) = exp(-(h/2)^2)*h;
   end
   if (1 < i && i < n)
     a(i,i-1) = -(1+c*((i-1)*h)^2)/h; a(i,i+1) = -(1+c*(i*h)^2)/h;
     a(i,i) = -(a(i,i-1)+a(i,i+1))+d*h;
     f(i) = exp(-((i-1/2)*h)^2)*h;
   end
   if (i == n)
     c1 = 1/h + alpha/2;
     a(i,i-1) = -(1+c*((i-1)*h)^2)/h;
     a(i,i) = (1+c*((i-1)*h)^2)/h + alpha*(1+c*(i*h)^2/(h*c1)) + d*h;
     f(i) = exp(-((i-1/2)*h)^2)*h+ (1+c*(i*h)^2)*peta/(h*c1);
   end
end
% Loesung
u = a\f;
end
