% Programm loesung114.m
% Milstein-Methode zur numerischen Loesung von
% SDE: dX = kappa(theta - X) dt + sigma*sqrt(X) dW, X(0) = Xzero ,
% Wurzel-Diffusionsprozess
%
% Wiener-Prozess ueber [0,1], dt = 2^(-8).
% Milstein auf einem Gitter mit Dt = R*dt 
% Input-Parameter: kappa, theta, sigma und Xzero
% Aufruf: loesung104(kappa,theta,sigma,x0);
function loesung104(kappa,theta,sigma,Xzero);
randn('state',100) % random seeding
T = 1 ; N = 2^8 ; dt = 1/N; 
dW = zeros(1,N); W = zeros(1,N); % Pre-Allokierung
dW = sqrt(dt)*randn(1,N) ; % Inkremente des Wiener-Prozesses
W = cumsum(dW) ; % Wiener-Prozess
% Mit R = 4,2,1 waehlt man die Feinheit der Zeitdiskretisierung (R=4 -> grob...)
R = 2 ; Dt = R*dt ; L = N/R; % L Schritte der numerischen Verfahren Dt = R*dt
Yem = zeros(1,L); % Pre-Allokierung
Ytemp = Xzero ;
j = 0;
while (j < L)
   j = j + 1;
   Winc = sum(dW(R*(j-1)+1:R*j)) ;
   Ytemp = Ytemp+Dt*kappa*(theta- Ytemp)+sigma*sqrt(Ytemp)*Winc...
                +0.25*sigma^2*(Winc^2-Dt);
   Yem(j) = Ytemp ;   %   Milstein-Loesung
end
plot([0:Dt:T],[Xzero,Yem],'g--*')
xlabel('t','FontSize',16); ylabel('X_t','FontSize',16);
end
