% Programm zur Berechnung des Integrals \int_0^{\pi/2} sin(x) dx
% mit der Monte-Carlo-Methode und einer nicht-konstanten Dichte p = 8x/pi^2
% input:  z, Feld von nsamples Zufallszahlen
% output: integral genaeherter Integralwert, fehler
% Aufruf: [integral,fehler] = montecarlo2(z,nsamples);
function [integral,fehler] = montecarlo2(z,nsamples);
mw = 0;
var = 0;
for j=1:nsamples
  xi = pi*sqrt(z(j))/2;
  dichte = 8*xi/pi^2;
  mw = mw + sin(xi)/dichte;
  var = var + (sin(xi)/dichte)^2;
end
integral = mw/nsamples;
fehler = sqrt((var/nsamples - integral^2)/nsamples);
end
